/**
 * SendinBlue API
 * SendinBlue provide a RESTFul API that can be used with any languages. With this API, you will be able to :   - Manage your campaigns and get the statistics   - Manage your contacts   - Send transactional Emails and SMS   - and much more...  You can download our wrappers at https://github.com/orgs/sendinblue  **Possible responses**   | Code | Message |   | :-------------: | ------------- |   | 200  | OK. Successful Request  |   | 201  | OK. Successful Creation |   | 202  | OK. Request accepted |   | 204  | OK. Successful Update/Deletion  |   | 400  | Error. Bad Request  |   | 401  | Error. Authentication Needed  |   | 402  | Error. Not enough credit, plan upgrade needed  |   | 403  | Error. Permission denied  |   | 404  | Error. Object does not exist |   | 405  | Error. Method not allowed  |   | 406  | Error. Not Acceptable  | 
 *
 * The version of the OpenAPI document: 3.0.0
 * Contact: contact@sendinblue.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


export class GetAccountAllOfPlan {
    /**
    * Displays the plan type of the user
    */
    'type': GetAccountAllOfPlan.TypeEnum;
    /**
    * This is the type of the credit, \"Send Limit\" is one of the possible types of credit of a user. \"Send Limit\" implies the total number of emails you can send to the subscribers in your account.
    */
    'creditsType': GetAccountAllOfPlan.CreditsTypeEnum;
    /**
    * Remaining credits of the user
    */
    'credits': number;
    /**
    * Date of the period from which the plan will start (only available for \"subscription\" and \"reseller\" plan type)
    */
    'startDate'?: string;
    /**
    * Date of the period from which the plan will end (only available for \"subscription\" and \"reseller\" plan type)
    */
    'endDate'?: string;
    /**
    * Only in case of reseller account. It implies the total number of child accounts you can add to your account.
    */
    'userLimit'?: number;

    static discriminator: string | undefined = undefined;

    static attributeTypeMap: Array<{name: string, baseName: string, type: string}> = [
        {
            "name": "type",
            "baseName": "type",
            "type": "GetAccountAllOfPlan.TypeEnum"
        },
        {
            "name": "creditsType",
            "baseName": "creditsType",
            "type": "GetAccountAllOfPlan.CreditsTypeEnum"
        },
        {
            "name": "credits",
            "baseName": "credits",
            "type": "number"
        },
        {
            "name": "startDate",
            "baseName": "startDate",
            "type": "string"
        },
        {
            "name": "endDate",
            "baseName": "endDate",
            "type": "string"
        },
        {
            "name": "userLimit",
            "baseName": "userLimit",
            "type": "number"
        }    ];

    static getAttributeTypeMap() {
        return GetAccountAllOfPlan.attributeTypeMap;
    }
}

export namespace GetAccountAllOfPlan {
    export enum TypeEnum {
        PayAsYouGo = <any> 'payAsYouGo',
        Free = <any> 'free',
        Subscription = <any> 'subscription',
        Sms = <any> 'sms',
        Reseller = <any> 'reseller'
    }
    export enum CreditsTypeEnum {
        SendLimit = <any> 'sendLimit'
    }
}
